// ImpactDllDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImpactDllDemo.h"
#include "ImpactDllDemoDlg.h"
#include "LoadDll.h"
#include "PrintSamples.h"
#include "Winspool.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE g_hComm		= INVALID_HANDLE_VALUE;//˿ھ
int nPortType		= -1; //˿
bool IsPrinter		= false;//жǷӡ
bool bSaveToTxt		= false;//Ƿѡݱ浽ļTest.txt˿·
HWND m_hHelpWnd;

extern HMODULE					g_hImpactdll;//̬

extern Impact_Open				VC_Impact_Open;//򿪶˿
extern Impact_Close				VC_Impact_Close;//رն˿
extern Impact_RTQueryStatus		VC_Impact_RTQueryStatus;//ʵʱ״̬ѯ
extern Impact_NETQueryStatus	VC_Impact_NETQueryStatus;//ӿڵ״̬ѯ
extern Impact_StartDoc			VC_Impact_StartDoc;//һĵ
extern Impact_EndDoc			VC_Impact_EndDoc;//һĵ
extern Impact_BeginSaveFile		VC_Impact_BeginSaveFile;//ݵļ
extern Impact_EndSaveFile		VC_Impact_EndSaveFile;//ݵļ
extern Impact_GetVersionInfo	VC_Impact_GetVersionInfo;//ȡǰ̬汾
extern Impact_ReadFile          VC_Impact_ReadFile;
/////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); 

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImpactDllDemoDlg dialog

CImpactDllDemoDlg::CImpactDllDemoDlg(CWnd* pParent)
	: CDialog(CImpactDllDemoDlg::IDD, pParent)
{
	m_strDrvName = _T("");
	m_strMsg = _T("");
	nPortType = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImpactDllDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STOPBITS, m_ctrlStopBits);
	DDX_Control(pDX, IDC_QUERY_STATUS, m_ctrlQueryStatus);
	DDX_Control(pDX, IDC_PRINT, m_ctrlPrint);
	DDX_Control(pDX, IDC_PARITY, m_ctrlParity);
	DDX_Control(pDX, IDC_LPT_NAME, m_ctrlLPTName);
	DDX_Control(pDX, IDC_IPADDRESS, m_ctrlIPAddr);
	DDX_Control(pDX, IDC_FLOW_CONTROL, m_ctrlFlowControl);
	DDX_Control(pDX, IDC_DRV_NAME, m_ctrlDrvName);
	DDX_Control(pDX, IDC_DATABITS, m_ctrlDataBits);
	DDX_Control(pDX, IDC_COM_NAME, m_ctrlComName);
	DDX_Control(pDX, IDC_CLOSE_PORT, m_ctrlClosePort);
	DDX_Control(pDX, IDC_BAUDRATE, m_ctrlBaudrate);
	DDX_CBString(pDX, IDC_DRV_NAME, m_strDrvName);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strMsg);
	DDX_Radio(pDX, IDC_PORT_COM, nPortType);
}

BEGIN_MESSAGE_MAP(CImpactDllDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PORT_COM, OnPortCom)
	ON_BN_CLICKED(IDC_PORT_LPT, OnPortLpt)
	ON_BN_CLICKED(IDC_PORT_USB, OnPortUsb)
	ON_BN_CLICKED(IDC_PORT_NET, OnPortNet)
	ON_BN_CLICKED(IDC_PORT_DRV, OnPortDrv)	
	ON_BN_CLICKED(IDC_OPEN_PORT, OnOpenPort)
	ON_BN_CLICKED(IDC_QUERY_STATUS, OnQueryStatus)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_WM_DESTROY()	
	ON_BN_CLICKED(IDC_CLOSE_PORT, OnClosePort)
	ON_BN_CLICKED(IDC_SAVE_TO_TXT, OnSaveToTxt)
	ON_WM_HELPINFO()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImpactDllDemoDlg message handlers

BOOL CImpactDllDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);
	

	if ( false == LoadImpactdll() )
	{
		// ̬ʧ, ˳
		AfxMessageBox("ض̬ʧܣ");
		CDialog::OnCancel();
		return false;
	}
	/*ʼʾ*/
	m_ctrlIPAddr.SetAddress(192,168,10,251);
	m_ctrlIPAddr.EnableWindow(false);
	
	m_ctrlComName.SetCurSel(0);
	m_ctrlDataBits.SetCurSel(1);
	m_ctrlBaudrate.SetCurSel(2);
	m_ctrlStopBits.SetCurSel(0);
	m_ctrlParity.SetCurSel(2);
	m_ctrlFlowControl.SetCurSel(1);

	m_ctrlLPTName.SetCurSel(0);

	SetDlgItemText(IDC_DRV_NAME,"BTP-M170(S)");

	int iMajor,iMinor;
	CString str,tmp;
	VC_Impact_GetVersionInfo(&iMajor,&iMinor);
	str = "һ汾V";
	tmp.Format("%d.%d",iMajor,iMinor);
	str += tmp;
	SetDlgItemText(IDC_EDIT_STATUS,str);

	/*öٵǰװĴӡ*/
	m_ctrlDrvName.ResetContent();
    UpdateData(TRUE); 
    DWORD   dwNeed, dwReturn, dwTemp, i;
	int ret;
	CString     m_strprinter;
	PRINTER_INFO_2   * pPrinterInfo;
	PRINTER_INFO_2  * m_pPrinterInfo;
	m_pPrinterInfo = new PRINTER_INFO_2; 

	ret = EnumPrinters( PRINTER_ENUM_LOCAL,NULL,2,(LPBYTE)m_pPrinterInfo,sizeof(PRINTER_INFO_2),&dwNeed,&dwReturn ); 
	delete m_pPrinterInfo; 
	if( ( m_pPrinterInfo = ( PRINTER_INFO_2 * )new BYTE[dwNeed] ) == NULL )
	{
		return FALSE;
	}

    ret =  EnumPrinters (PRINTER_ENUM_LOCAL,NULL,2,(LPBYTE)m_pPrinterInfo,dwNeed,&dwTemp,&dwReturn);

	CString str1;
	for (i = 0; i < dwReturn; i++ )//Show Driver Name
	{
		pPrinterInfo = m_pPrinterInfo + i;
		str1.Format("%s",pPrinterInfo->pPrinterName );
		if( ( str1.Find( "BT", 0 ) >= 0 ) )
		{
			m_ctrlDrvName.AddString( pPrinterInfo->pPrinterName ); 
		}                 
     }
	m_ctrlDrvName.SetCurSel(0);
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control	
}

void CImpactDllDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);	
}


void CImpactDllDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CImpactDllDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CImpactDllDemoDlg::OnPortCom() //˿ѡΪ
{
	m_ctrlComName.EnableWindow(true);
	m_ctrlDataBits.EnableWindow(true);
	m_ctrlBaudrate.EnableWindow(true);
	m_ctrlStopBits.EnableWindow(true);
	m_ctrlParity.EnableWindow(true);
	m_ctrlFlowControl.EnableWindow(true);

	m_ctrlLPTName.EnableWindow(false);
	m_ctrlIPAddr.EnableWindow(false);
	m_ctrlDrvName.EnableWindow(false);

	SetDlgItemText(IDC_EDIT_STATUS,"˿ѡΪ");
	VC_Impact_Close(g_hComm,nPortType);
	nPortType = 0;
	m_ctrlQueryStatus.EnableWindow(false);
	m_ctrlPrint.EnableWindow(false);
	m_ctrlClosePort.EnableWindow(false);
	GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);
}


void CImpactDllDemoDlg::OnPortLpt() //˿ѡΪ
{
	m_ctrlLPTName.EnableWindow(true);
	
	m_ctrlComName.EnableWindow(false);
	m_ctrlDataBits.EnableWindow(false);
	m_ctrlBaudrate.EnableWindow(false);
	m_ctrlStopBits.EnableWindow(false);
	m_ctrlParity.EnableWindow(false);
	m_ctrlFlowControl.EnableWindow(false);	

	m_ctrlIPAddr.EnableWindow(false);

	m_ctrlDrvName.EnableWindow(false);

	SetDlgItemText(IDC_EDIT_STATUS,"˿ѡΪ");
	VC_Impact_Close(g_hComm,nPortType);
	nPortType = 1;
	m_ctrlQueryStatus.EnableWindow(false);
	m_ctrlPrint.EnableWindow(false);
	m_ctrlClosePort.EnableWindow(false);
	GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);	
}

void CImpactDllDemoDlg::OnPortUsb() //˿ѡΪUSB
{
	m_ctrlComName.EnableWindow(false);
	m_ctrlDataBits.EnableWindow(false);
	m_ctrlBaudrate.EnableWindow(false);
	m_ctrlStopBits.EnableWindow(false);
	m_ctrlParity.EnableWindow(false);
	m_ctrlFlowControl.EnableWindow(false);	

	m_ctrlLPTName.EnableWindow(false);

	m_ctrlIPAddr.EnableWindow(false);

	m_ctrlDrvName.EnableWindow(false);

	SetDlgItemText(IDC_EDIT_STATUS,"˿ѡΪUSB");
	VC_Impact_Close(g_hComm,nPortType);
	nPortType = 2;
	m_ctrlQueryStatus.EnableWindow(false);
	m_ctrlPrint.EnableWindow(false);
	m_ctrlClosePort.EnableWindow(false);
	GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);	
}

void CImpactDllDemoDlg::OnPortNet() //˿ѡΪӿ
{
	m_ctrlIPAddr.EnableWindow(true);
	
	m_ctrlComName.EnableWindow(false);
	m_ctrlDataBits.EnableWindow(false);
	m_ctrlBaudrate.EnableWindow(false);
	m_ctrlStopBits.EnableWindow(false);
	m_ctrlParity.EnableWindow(false);
	m_ctrlFlowControl.EnableWindow(false);	

	m_ctrlLPTName.EnableWindow(false);

	m_ctrlDrvName.EnableWindow(false);

	SetDlgItemText(IDC_EDIT_STATUS,"˿ѡΪӿ");
	VC_Impact_Close(g_hComm,nPortType);
	nPortType = 3;
	m_ctrlQueryStatus.EnableWindow(false);
	m_ctrlPrint.EnableWindow(false);
	m_ctrlClosePort.EnableWindow(false);
	GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);	
}

void CImpactDllDemoDlg::OnPortDrv() //˿ѡΪ
{
	m_ctrlDrvName.EnableWindow(true);
	
	m_ctrlComName.EnableWindow(false);
	m_ctrlDataBits.EnableWindow(false);
	m_ctrlBaudrate.EnableWindow(false);
	m_ctrlStopBits.EnableWindow(false);
	m_ctrlParity.EnableWindow(false);
	m_ctrlFlowControl.EnableWindow(false);	

	m_ctrlLPTName.EnableWindow(false);

	m_ctrlIPAddr.EnableWindow(false);	

	SetDlgItemText(IDC_EDIT_STATUS,"˿ѡΪ");
	VC_Impact_Close(g_hComm,nPortType);
	nPortType = 4;
	m_ctrlQueryStatus.EnableWindow(false);
	m_ctrlPrint.EnableWindow(false);
	m_ctrlClosePort.EnableWindow(false);
	GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);
	
}

void CImpactDllDemoDlg::OnOpenPort() 
{
	UpdateData(true);
	if (!(g_hComm==INVALID_HANDLE_VALUE))
	{
		VC_Impact_Close(g_hComm,nPortType);
	}


	if(0 == nPortType) //Ҫ򿪵Ķ˿Ϊ
	{	
		CString strPortName;

		int iBaudrate;
		int iDataBits;
		int iStopBits;
		int iParity;
		int iFlowControl;

		m_ctrlComName.GetLBText(m_ctrlComName.GetCurSel(),strPortName);
		iDataBits = m_ctrlDataBits.GetCurSel()+7;//Ϊ0ʾλΪ7Ϊ1ʾ8ĵ
		int tmp = m_ctrlStopBits.GetCurSel();//ĵ
		if(0 == tmp)//ֹͣλΪ1
		{
			iStopBits = 1;
		}
		if(1 == tmp)//ֹͣλΪ2
		{
			iStopBits = 2;
		}
		int temp = m_ctrlParity.GetCurSel();//ĵ
		if(0 == temp)//żУ
		{
			iParity = 2;
		}
		else if(1 == temp)//У
		{
			iParity = 1;
		}
		else//У
		{
			iParity = 0;
		}
		int iRet = m_ctrlFlowControl.GetCurSel();//ĵ
		if(0 == iRet)//Xon/Xoff
		{
			iFlowControl = 2;
		}else if(1 == iRet)//Impact_COM_RTS_CTS
		{
			iFlowControl = 1;
		}else if(2 == iRet)//Impact_COM_DTR_DSR
		{
			iFlowControl = 0;
		}
		else//Impact_COM_NO_HANDSHAKE
		{
			iFlowControl = 3;
		}

		switch(m_ctrlBaudrate.GetCurSel())
		{		
		case 0:
			iBaudrate = 2400;
			break;

		case 1:
			iBaudrate = 4800;
			break;

		case 2:
			iBaudrate = 9600;
			break;

		case 3:
			iBaudrate = 19200;
			break;

		case 4:
			iBaudrate = 38400;
			break;

		case 5:
			iBaudrate = 57600;
			break;

		case 6:
			iBaudrate = 115200;
			break;

		default:
			iBaudrate = 9600;
			break;
		}

		g_hComm = VC_Impact_Open(strPortName,iBaudrate,iDataBits,iStopBits,iParity,iFlowControl);
	}
	
	if(1 == nPortType) //Ҫ򿪵Ķ˿Ϊ
	{
		IsPrinter = false;

		CString strPortName;
		m_ctrlLPTName.GetLBText(m_ctrlLPTName.GetCurSel(),strPortName);
		g_hComm = VC_Impact_Open(strPortName,0,0,0,0,Impact_OPEN_PARALLEL_PORT);
	}

	if(2 == nPortType) //Ҫ򿪵Ķ˿ΪUSB
	{
		IsPrinter = false;

		g_hComm = VC_Impact_Open("BYUSB-0",0,0,0,0,Impact_OPEN_BYUSB_PORT);
	}

	if(3 == nPortType) //Ҫ򿪵Ķ˿Ϊӿ
	{
		if(m_ctrlIPAddr.IsBlank())
		{
			m_strMsg = "IPַΪգ";
			m_ctrlIPAddr.SetFocus();
			UpdateData(false);
			return;
		}
		else
		{
			IsPrinter = false;

			CString tmp;
			BYTE  nField1, nField2, nField3, nField4;

			m_ctrlIPAddr.GetAddress(nField1, nField2, nField3, nField4);
			
			tmp.Format("%d",nField1);
			strNetPortName = tmp;
			strNetPortName += ".";

			tmp.Format("%d",nField2);
			strNetPortName += tmp;
			strNetPortName += ".";

			tmp.Format("%d",nField3);
			strNetPortName += tmp;
			strNetPortName += ".";

			tmp.Format("%d",nField4);
			strNetPortName += tmp;

			g_hComm = VC_Impact_Open(strNetPortName,0,0,0,0,Impact_OPEN_NETPORT);
		}
	}

	if(4 == nPortType) //Ҫ򿪵Ķ˿Ϊ
	{
		if("" == m_strDrvName)
		{
			m_strMsg = "Ϊգ";
			m_ctrlDrvName.SetFocus();
			UpdateData(false);
			return;
		}
		else
		{
			IsPrinter = true;
			g_hComm = VC_Impact_Open(m_strDrvName,0,0,0,0,Impact_OPEN_PRINTNAME);
		}
	}

	if (g_hComm != INVALID_HANDLE_VALUE) //жϴ򿪶˿ںֵ
	{
		GetDlgItem(IDC_OPEN_PORT)->EnableWindow(false);
		m_strMsg = "˿ڴ򿪳ɹ";
		m_ctrlPrint.EnableWindow(true);
		m_ctrlClosePort.EnableWindow(true);
		if(nPortType != 1 && nPortType != 4)//ںӿڲ֧״̬ѯ
		{
			m_ctrlQueryStatus.EnableWindow(true);
		}
	}
	else
	{
		m_strMsg = "˿ڴʧܣ";
		m_ctrlQueryStatus.EnableWindow(false);
		m_ctrlPrint.EnableWindow(false);
		m_ctrlClosePort.EnableWindow(false);
	}

	UpdateData(false);
	m_strMsg = "";
}

void CImpactDllDemoDlg::OnQueryStatus() //ѯ״̬
{
	char Data = 0;
	int nRet;
	int nBytesToRead = 4;
	int nTimeouts = 30000;
	nRet=VC_Impact_ReadFile(g_hComm,nPortType,&Data,nBytesToRead,nTimeouts);
/*	if(3 == nPortType)
	{
		nRet = VC_Impact_NETQueryStatus(nPortType,(LPSTR)(LPCTSTR)strNetPortName,&Status);
	}
	else
	{
		nRet = VC_Impact_RTQueryStatus(g_hComm,nPortType,&Status);
	}
	if(Impact_FAIL == nRet)
	{
		m_strMsg = "ѯ״̬ʧܣ";
		GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);
		GetDlgItem(IDC_QUERY_STATUS)->EnableWindow(false);
		GetDlgItem(IDC_PRINT)->EnableWindow(false);
		GetDlgItem(IDC_CLOSE_PORT)->EnableWindow(false);
	}
	else
	{	
		int iBits[8];
		for (int i = 0; i < 8; i++)
		{
			iBits[i] = (Status >> i) & 0x01;
		}
		if(Status == 1)
		{
			m_strMsg = "һ";
		}
		else
		{
			m_strMsg = "";
			if (iBits[0] == 0)
			{
				m_strMsg += "Ǯ򿪣";
			}
			
			if (iBits[1] == 1)
			{
				m_strMsg += "ӡѻ";
			}
			
			if (iBits[2] == 1)
			{
				m_strMsg += "ϸǴ򿪣";
			}

			if (iBits[3] == 1)
			{
				m_strMsg += "ڽֽ";
			}
			
			if (iBits[4] == 1)
			{
				m_strMsg += "ӡ";
			}
			
			if (iBits[5] == 1)
			{
				m_strMsg += "е";
			}
			
			if (iBits[6] == 1)
			{
				m_strMsg += "ֽ";
			}
			
			if (iBits[7] == 1)
			{
				m_strMsg += "ȱֽ";
			}
		}
	}
*/
	UpdateData(false);	
}

void CImpactDllDemoDlg::OnPrint() 
{
	UpdateData(TRUE);
	if(IsPrinter)  //ѡӡ
	{
		VC_Impact_StartDoc(g_hComm,nPortType);
	}

	if (PrintSamples(g_hComm,nPortType))
	{
		m_strMsg = "ӡɹ";
	}
	else
	{
		m_strMsg = "ӡʧܣ";
		GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);
		GetDlgItem(IDC_QUERY_STATUS)->EnableWindow(false);		
		GetDlgItem(IDC_PRINT)->EnableWindow(false);
		GetDlgItem(IDC_CLOSE_PORT)->EnableWindow(false);
	}
	if(IsPrinter)  //ѡӡ
	{
		VC_Impact_EndDoc(g_hComm,nPortType);
	}
	UpdateData(false);	
}

void CImpactDllDemoDlg::OnClosePort() 
{
	int nRet;
	nRet = VC_Impact_Close(g_hComm,nPortType);
	if(Impact_FAIL == nRet)
	{
		m_strMsg = "˿ڹرʧܣ";
	}
	else if(Impact_ERROR_INVALID_HANDLE == nRet)
	{
		m_strMsg = "˿ڹرʧܣ";
	}
	else
	{
		GetDlgItem(IDC_OPEN_PORT)->EnableWindow(true);
		m_strMsg = "˿ڹرճɹ";
		m_ctrlQueryStatus.EnableWindow(false);
		m_ctrlPrint.EnableWindow(false);
		m_ctrlClosePort.EnableWindow(false);		
	}

	UpdateData(false);	
}

void CImpactDllDemoDlg::OnDestroy() //ڹر
{
	CDialog::OnDestroy();
	
	if(INVALID_HANDLE_VALUE != g_hComm)
	{
		VC_Impact_Close(g_hComm,nPortType);
	}
	if(g_hImpactdll)
	{
		UnloadImpactdll();
	}
}

void CImpactDllDemoDlg::OnSaveToTxt() 
{
	if(bSaveToTxt)
	{
		bSaveToTxt = false;
	}
	else
	{
		bSaveToTxt = true;
	}	
}

BOOL CImpactDllDemoDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	m_hHelpWnd = ::FindWindow(NULL, "ImpactDLL˵"); 
	if(NULL == m_hHelpWnd)
	{
		ShellExecute(NULL,"open",".\\ImpactDLL_API_CN.chm",NULL,NULL,SW_SHOW);
	}
	else
	{
		::BringWindowToTop(m_hHelpWnd);
		::OpenIcon(m_hHelpWnd);
	}
	::ShowWindow(m_hHelpWnd,SW_MAXIMIZE);
	return TRUE;
	
	return CDialog::OnHelpInfo(pHelpInfo);
}

void CImpactDllDemoDlg::OnOK() 
{

}

