unit ImpactDllDemoForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,ImpactdllFuncs,IniFiles,
  winspool, XPMan;
type
  TMainForm = class(TForm)
    PortSet: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    cbPortName: TComboBox;
    cbBaud: TComboBox;
    cbData: TComboBox;
    cbParity: TComboBox;
    cbStop: TComboBox;
    cbFlow: TComboBox;
    cbLPT: TComboBox;
    ChkWrite: TCheckBox;
    OpenPort: TButton;
    Aboutinquire: TButton;
    edQuery: TEdit;
    Print: TButton;
    ClosePort: TButton;
    IP1: TEdit;
    IP2: TEdit;
    IP3: TEdit;
    IP4: TEdit;
    PortChoice: TRadioGroup;
    edDrive: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure IP4KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure OpenPortClick(Sender: TObject);
    procedure AboutinquireClick(Sender: TObject);
    procedure ClosePortClick(Sender: TObject);
    procedure PrintClick(Sender: TObject);
    procedure IP1KeyPress(Sender: TObject; var Key: Char);
    procedure IP2KeyPress(Sender: TObject; var Key: Char);
    procedure IP3KeyPress(Sender: TObject; var Key: Char);
    procedure PortChoiceClick(Sender: TObject);
    procedure cbPortNameChange(Sender: TObject);
    procedure IP1Change(Sender: TObject);
    procedure IP2Change(Sender: TObject);
    procedure IP3Change(Sender: TObject);
    procedure IP4Change(Sender: TObject);
    procedure cbLPTChange(Sender: TObject);
  private
    { Private declarations }
    procedure PrintSample();
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  b_OpenPort :boolean;                     //Ƿ򿪶˿
  Portname,Portname1 : String;             //˿
  baudRate1,StopBit,DataBit,HandShake,Paritytemp :Integer;
  ComName,LptName,UsbName: integer;
  Porttype :integer=0;                     //˿
  g_hComm:Thandle=INVALID_HANDLE_VALUE;    //򿪶˿ڵľ
  ipConst : String;                        //ӿIPֵ
  i_portIndex : integer;

implementation

{$R *.dfm}

//ú״̬ѯĹ----------------------------------------------------
procedure TMainForm.AboutinquireClick(Sender: TObject);
var
  bits: array [0..7] of Integer;
  chStatus: Char;
  i: Integer;
  iReturn: Integer;
  strInfo: string;
begin
  if g_hComm = INVALID_HANDLE_VALUE  then
  begin
    edQuery.Text :='˿δ';
    exit;
  end;
  strInfo := '';
   if PortChoice.ItemIndex=1 then //̫ͨӿڲѯӡ״̬
     iReturn:=Impact_NETQueryStatus(Porttype,PChar(ipConst),@chStatus)
   else
   begin //ͨڡUSBӿڲѯӡ״̬
     iReturn := Impact_RTQueryStatus(g_hComm,Porttype,@chStatus);
   end;
  If iReturn <> Impact_SUCCESS Then
  begin
    strInfo := 'ѯ״̬ʧܣ';
    edQuery.Text := strInfo;
    OpenPort.Enabled:=true;
    Aboutinquire.Enabled:=false;
    Print.Enabled:=False;
    ClosePort.Enabled:=False;
    exit;
  End;

  If (Integer(chStatus) = 1) then
  begin
   edQuery.Text := 'һ';
    exit;
  end;

  for i := 0 to 7 do
  begin
    bits[i] := (Integer(chStatus) shr i) And 1;
  end;

  if bits[0] = 0 then
    strInfo := 'Ǯ򿪣';

	if bits[1] = 1 then
    strInfo := strInfo + 'ӡѻ';

	if bits[2] = 1 then
	  strInfo := strInfo + 'ϸǴ򿪣';

  if bits[3] = 1 then
    strInfo := Strinfo + 'ڽֽ';

	if bits[4] = 1 then
	  strInfo := strInfo + 'ӡ';

	if bits[5] = 1 then
	  strInfo := strInfo + 'е';

	if bits[6] = 1 then
	  strInfo := strInfo + 'ֽ';

	if bits[7] = 1 then
    strInfo := strInfo + 'ȱֽ';

  if strInfo = '' then
    strInfo := 'һ!';

  edQuery.Text:= strInfo;
end;

//ıѡȽѴ򿪵Ķ˿ڹر------------------------------------------
procedure TMainForm.cbLPTChange(Sender: TObject);
begin
  if  g_hComm  <> INVALID_HANDLE_VALUE then
  begin
    Impact_Close(g_hComm,Porttype);
    g_hComm := INVALID_HANDLE_VALUE;
  end;
end;

procedure TMainForm.cbPortNameChange(Sender: TObject);
begin
  if  g_hComm  <> INVALID_HANDLE_VALUE then
  begin
    Impact_Close(g_hComm,Porttype);
    g_hComm := INVALID_HANDLE_VALUE;
  end;
end;

//˿ڹرյĲ----------------------------------------------------------------
procedure TMainForm.ClosePortClick(Sender: TObject);
begin
  Impact_Close(g_hComm,Porttype); //رյǰ˿
  g_hComm := INVALID_HANDLE_VALUE;
  ClosePort.Enabled:=False;
  Aboutinquire.Enabled:=False;
  print.Enabled:=False;
  OpenPort.Enabled:=true;
end;

//ð汾˵Ӧ汾Ϣ------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
var
  m_version,aaa : String;
  X,Y:integer;
  p1,p2:Pinteger;
begin
    p1:=@X;
    p2:=@Y;
    m_version := Format('һ汾--%d',[Impact_GetVersionInfo(@X,@Y)]);
    edQuery.Text :='һ汾V'+IntToStr(X)+'.'+IntToStr(Y);
    cbLPT.Enabled:=False;
    edDrive.Enabled:=False;
    IP1.Enabled:=False;
    IP2.Enabled:=False;
    IP3.Enabled:=False;
    IP4.Enabled:=False;
    ClosePort.Enabled:=False;
    Print.Enabled:=False;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  len,BytesTemp         :DWORD;
  BytesNeed,BytesReturn :DWORD;
  i                     :Integer;
  PrinterInfo,PrinterInfo1:PPrinterInfo2;
begin
  len := sizeof(PRINTER_INFO_2);
  GetMem(PrinterInfo,len + 1);
  FillMemory(PrinterInfo,len,$00);
  BytesNeed :=  0;
  EnumPrinters( PRINTER_ENUM_LOCAL,Nil,2,PrinterInfo,len,BytesNeed,BytesReturn);
  FreeMem(PrinterInfo);
  PrinterInfo :=  Nil;

  if(BytesNeed = 0)  then Exit;
  GetMem(PrinterInfo,BytesNeed + 1);
  if(PrinterInfo  = Nil)  then  Exit;
  FillMemory(PrinterInfo,BytesNeed,$00);
  EnumPrinters( PRINTER_ENUM_LOCAL,Nil,2,PrinterInfo,BytesNeed,BytesTemp,BytesReturn);
  edDrive.Clear;
  for i :=  0 to  BytesReturn - 1 do
  begin
    PrinterInfo1:=PrinterInfo;
    Inc(PrinterInfo1,i);
    if POS('BT',PrinterInfo1.pPrinterName) <> 0 then edDrive.Items.Add(PrinterInfo1.pPrinterName);
  end;
  edDrive.ItemIndex:=0;
  FreeMem(PrinterInfo);
end;

//ӿڵ------------------------------------------------------------
procedure TMainForm.IP1Change(Sender: TObject);
begin
if IP1.Text<>'' then
  begin
    if (StrToInt(IP1.Text)>255)or (StrToInt(IP1.Text)<0) then
    begin
     IP1.Text:='255';
    end;
  end;
end;

procedure TMainForm.IP1KeyPress(Sender: TObject; var Key: Char);
begin
  IP1.SetSelTextBuf('');
  if(Key = '.') then
  begin
    IP2.SetFocus();
    Key :=  #0;
    Exit;
  end;
  if(length(IP1.Text) >= 3) and (Key <> #8) then
  begin
    Key := #0;
    MessageBeep(1);
    exit;
  end;
  if not (Key in ['0'..'9',#8]) then
  begin
    Key := #0;
    MessageBeep(1);
  end;
end;

procedure TMainForm.IP2Change(Sender: TObject);
begin
  if IP2.Text<>'' then
  begin
    if (StrToInt(IP2.Text)>255)or (StrToInt(IP2.Text)<0) then
    begin
     IP2.Text:='255';
    end;
  end;
end;

procedure TMainForm.IP2KeyPress(Sender: TObject; var Key: Char);
begin
  IP2.SetSelTextBuf('');
  if(Key = '.') then
  begin
    IP3.SetFocus();
    Key :=  #0;
    Exit;
  end;
  if(length(IP2.Text) >= 3) and (Key <> #8) then
  begin
    Key := #0;
    MessageBeep(1);
    exit;
  end;
  if not (Key in ['0'..'9',#8]) then
  begin
    Key := #0;
    MessageBeep(1);
  end;
end;

procedure TMainForm.IP3Change(Sender: TObject);
begin
  if IP3.Text<>'' then
  begin
    if (StrToInt(IP3.Text)>255)or (StrToInt(IP3.Text)<0) then
    begin
     IP3.Text:='255';
    end;
  end;
end;

procedure TMainForm.IP3KeyPress(Sender: TObject; var Key: Char);
begin
  IP3.SetSelTextBuf('');
  if(Key = '.') then
  begin
    IP4.SetFocus();
    Key :=  #0;
    Exit;
  end;
  if(length(IP3.Text) >= 3) and (Key <> #8) then
  begin
    Key := #0;
    MessageBeep(1);
    exit;
  end;
  if not (Key in ['0'..'9',#8]) then
  begin
    Key := #0;
    MessageBeep(1);
  end;
end;

procedure TMainForm.IP4Change(Sender: TObject);
begin
  if IP4.Text<>'' then
  begin
    if (StrToInt(IP4.Text)>255)or (StrToInt(IP4.Text)<0) then
    begin
     IP4.Text:='255';
    end;
  end;
end;

procedure TMainForm.IP4KeyPress(Sender: TObject; var Key: Char);
begin
  IP4.SetSelTextBuf('');
  //롮'.',ƶһؼ
  if(Key = '.') then
  begin
    ChkWrite.SetFocus();
    Key :=  #0;
    Exit;
  end;
  if(length(IP4.Text) >= 3) and (Key <> #8) then
  begin
    Key := #0;
    MessageBeep(1);
    exit;
  end;
  if not (Key in ['0'..'9',#8]) then
  begin
    Key := #0;
    MessageBeep(1);
  end;
end;

//򿪶˿ڲ̴ж˿ڵĺù------------------------------------
procedure TMainForm.OpenPortClick(Sender: TObject);
var
  baudrate: integer;    //
  portName: pchar;      //˿
  i_DriverData: pchar;  //
  I_cbData: integer;    //λ
begin
  if g_hComm <> INVALID_HANDLE_VALUE then
  begin
    Impact_Close(g_hComm,Porttype);
    g_hComm := INVALID_HANDLE_VALUE;
    ClosePort.Enabled:=False;
  end;
  if i_portIndex = 0 then //ڲ
  begin
    //ʹܴڸѡ,˿ڲΪ
    case cbPortName.ItemIndex of
      0: portName := 'COM1';
      1: portName := 'COM2';
      2: portName := 'COM3';
      3: portName := 'COM4';
      4: portName := 'COM5';
      5: portName := 'COM6';
      6: portName := 'COM7';
      7: portName := 'COM8';
      8: portName := 'COM9';
      9: portName := 'COM10';
    end;
    case cbBaud.ItemIndex of
      0: baudrate := 2400;
      1: baudrate := 4800;
      2: baudrate := 9600;
      3: baudrate := 19200;
      4: baudrate := 38400;
      5: baudrate := 57600;
      6: baudrate := 115200;
    end;
    case cbData.ItemIndex of
      0: I_cbData:=7;
      1: I_cbData:=8;
    end;
    g_hComm := Impact_Open(portName, baudrate, I_cbData, cbStop.ItemIndex+1, cbParity.ItemIndex, cbFlow.ItemIndex);
  end
  else if i_portIndex = 1 then  //ӿڲIPӶȷҪĲ
  begin
    edQuery.Text:='ѡ';
    ipConst:=(IP1.Text+'.'+IP2.Text+'.'+IP3.Text+'.'+IP4.Text);
    if (IP1.Text='')or (IP2.Text='')or (IP3.Text='') or (IP4.Text='') then
    begin
      edQuery.Text:='IPַΪ';
      exit;
    end;
    g_hComm := Impact_Open(PChar(ipConst),0,0,0,0,Impact_OPEN_NETPORT);
  end
  else if i_portIndex =2  then  //ڲ˴ֻоڸҪ
  begin
     case cbLPT.ItemIndex of
       0:  portName:='LPT1';
       1:  portName:='LPT2';
     end;
    g_hComm := Impact_Open(portName,0, 0,0,0,Impact_OPEN_PARALLEL_PORT);
  end
  else if i_portIndex = 3 then  //öѰװĴӡ
  begin
    if edDrive.Text='' then
    begin
      edQuery.text:='Ϊգ';
      exit;
    end;
    i_DriverData:=PAnsiChar(edDrive.Text);
    g_hComm := Impact_Open(i_DriverData,0,0,0,0,Impact_OPEN_PRINTNAME); //ѾڵĴӡ
  end
  else
  begin
    g_hComm := Impact_Open('BYUSB-0', 0, 0, 0, 0, Impact_OPEN_BYUSB_PORT);  //USBӿڲ
  end;

  //ж϶˿Ƿ------------------------------------------------------------
  if g_hComm <> INVALID_HANDLE_VALUE then
  begin
    Print.Enabled := true;
    edQuery.Text := '˿ڴ򿪳ɹ';
    OpenPort.Enabled:=False;
    ClosePort.Enabled:=True;
    if i_portIndex =2 then
    begin
       Aboutinquire.Enabled:=False;
    end;
    if (i_portIndex <>2) and (i_portIndex <> 3) then
    begin
      Aboutinquire.Enabled:=true;
    end;
    Print.Enabled:=True;
    ClosePort.Enabled:=True;
  end else
  begin
    Print.Enabled := true;
    edQuery.Text := '˿ڴʧܣ';
    Aboutinquire.Enabled:=False;
    Print.Enabled:=False;
    ClosePort.Enabled:=False;
  end;
end;

//ѡĲͬʾ棬ݶ˿ѡĲͬʾϢ--------------------
procedure TMainForm.PortChoiceClick(Sender: TObject);
begin
  if  g_hComm  <> INVALID_HANDLE_VALUE then
  begin
    Impact_Close(g_hComm,Porttype);
    g_hComm := INVALID_HANDLE_VALUE;
    OpenPort.Enabled:=true;
    ClosePort.Enabled:=False;
    Print.Enabled:=False;
    Aboutinquire.Enabled:=False;
  end;
  i_portIndex :=  PortChoice.ItemIndex;
  if i_portIndex = 0 then
  begin
    cbLPT.Enabled:=False;
    edDrive.Enabled:=False;
    IP1.Enabled:=False;
    IP2.Enabled:=False;
    IP3.Enabled:=False;
    IP4.Enabled:=False;
    cbPortName.Enabled:=true;
    cbData.Enabled:=true;
    cbBaud.Enabled:=True;
    cbStop.Enabled:=true;
    cbParity.Enabled:=true;
    cbFlow.Enabled:=True;
    edQuery.Text:='˿ѡΪ';
    Porttype := 0;
  end
  else if i_portIndex = 1 then
  begin
    cbLPT.Enabled:=False;
    edDrive.Enabled:=False;
    IP1.Enabled:=true;
    IP2.Enabled:=true;
    IP3.Enabled:=true;
    IP4.Enabled:=true;
    cbPortName.Enabled:=False;
    cbData.Enabled:=False;
    cbBaud.Enabled:=False;
    cbStop.Enabled:=False;
    cbParity.Enabled:=False;
    cbFlow.Enabled:=False;
    edQuery.Text:='˿ѡΪӿ';
    Porttype := 3;
  end
  else if i_portIndex =2  then
  begin
    edQuery.Text:='˿ѡΪ';
    cbLPT.Enabled:=True;
    edDrive.Enabled:=False;
    IP1.Enabled:=False;
    IP2.Enabled:=False;
    IP3.Enabled:=False;
    IP4.Enabled:=False;
    cbPortName.Enabled:=False;
    cbData.Enabled:=False;
    cbBaud.Enabled:=False;
    cbStop.Enabled:=False;
    cbParity.Enabled:=False;
    cbFlow.Enabled:=False;
    Porttype := 1;
  end
  else if i_portIndex = 3 then
  begin
    edQuery.Text:='˿ѡΪ';
    cbLPT.Enabled:=False;
    edDrive.Enabled:=True;
    IP1.Enabled:=False;
    IP2.Enabled:=False;
    IP3.Enabled:=False;
    IP4.Enabled:=False;
    cbPortName.Enabled:=False;
    cbData.Enabled:=False;
    cbBaud.Enabled:=False;
    cbStop.Enabled:=False;
    cbParity.Enabled:=False;
    cbFlow.Enabled:=False;
    Porttype := 4;
  end
  else
  begin
    edQuery.Text:='˿ѡΪUSB';
    cbLPT.Enabled:=False;
    edDrive.Enabled:=False;
    IP1.Enabled:=False;
    IP2.Enabled:=False;
    IP3.Enabled:=False;
    IP4.Enabled:=False;
    cbPortName.Enabled:=False;
    cbData.Enabled:=False;
    cbBaud.Enabled:=False;
    cbStop.Enabled:=False;
    cbParity.Enabled:=False;
    cbFlow.Enabled:=False;
    Porttype := 2;
  end;
end;

//ӡľ----------------------------------------------------------------
procedure TMainForm.PrintClick(Sender: TObject);
var
  printwidth: integer;
  printtype :integer;
begin
  if ChkWrite.Checked  then
  begin
    Impact_BeginSaveFile(g_hComm,PAnsiChar(ExtractFilePath(paramstr(0))+'Test.txt'),false);
  end;
  if i_portIndex =  3 then //ʹӿڣҵʼʱҪִСImpact_StartDoc
  begin
    Impact_StartDoc(g_hComm,Porttype);
  end;
  PrintSample(); //ӡʾ
  if i_portIndex=3 then //ʹӿڣҵʱҪִСImpact_EndDoc
  begin
    if Impact_EndDoc(g_hComm,Porttype)=true then
    begin
      edQuery.Text:='ӡɹ';
    end;
  end;
end;

//ʾŵʽ------------------------------------------------------------
procedure TMainForm.PrintSample();
var
  strBitImages: array[0..2] of string;
  iCount: Integer;
  iReturn:Integer;
  ErrBmpID:PInteger;
  pszData:PChar;
begin
  //Ƿѷ͵ӡͨѶ˿ڵݺָ浽ļ"Test.dat"
  if ChkWrite.Checked = true then Impact_BeginSaveFile(g_hComm,'Test.dat', false);

  // λͼ Flash
  strBitImages[0] := 'Kitty.bmp';
  strBitImages[1] := 'Look.bmp';
  iCount := 2;
  Impact_PreDownloadBmpsToFlash(g_hComm,Porttype,@strBitImages[0],iCount,ErrBmpID);
  if integer(ErrBmpID) <> 1001 then
      Showmessage('ص' + inttostr(integer(ErrBmpID)) + 'λͼʧܣ' );

  //ַҼ
	Impact_SetRightSpacing(g_hComm,Porttype,0);
  //ַи
  Impact_SetLineSpacing(g_hComm,Porttype,26);
  //ӡֽһ
  Impact_FeedLine(g_hComm,Porttype);

  //ӡıʾ
  ///  /////////////////////////////////////////////////////////
  /// ı Impact_S_TextOut 
  /// Impact_S_TextOut(
  ///   hPort:Thandle;           򿪵Ķ˿ھ
  ///   nPortType:Integer;       ˿ͣ
  ///   pszString:pchar;         ıַ
  ///   nWidthTimes:integer;     ַָĿȷϵķŴ 1~2
  ///   nHeightTimes:integer;    ַָ߶ȷϵķŴ 1~2
  ///   nFontType:integer;       ַָͣ
  ///   nFontStyle:integer)      ַָ
  ///
  /// ˺ӡַһֱú Impact_FeedLine
  /// ʱŽʵʵĽֽӡĶǣַѾڿɴӡʱ
  /// ôԶֽӡ
  ///  ////////////////////////////////////////////////////////

	Impact_S_TextOut(g_hComm,Porttype,'  й̫ƽٱչɷ޹˾ֹ˾',  1, 2, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_BOLD);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'CHINA PACIFIC LIFE INSURANCE CO.,LTD', 1, 1, Impact_FONT_TYPE_COMPRESSED,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'      ˿˺ձյ',  1, 2, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'    շվݣ',  2, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'ţAA03250',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'ս˺ս     Ԫ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'        ˺ҽƱս  ҼԪ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'ޣԵǳ˽ͨ뿪ͨʱֹ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'շѣ ҼԪ    վƣ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'Ʊ룺           ˳ڣ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'ϵͳţ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'                £',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_TextOut(g_hComm,Porttype,'      ÿ޹ݣЧ',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);

  Impact_FeedLine(g_hComm,Porttype);
  Impact_FeedLine(g_hComm,Porttype);
  
  //ӡFlashеLogoλͼ:
  Impact_S_TextOut(g_hComm,Porttype,'ӡLogoʾ-----------------------',  1, 1, Impact_FONT_TYPE_CHINESE,Impact_FONT_STYLE_NORMAL);
  Impact_FeedLine(g_hComm,Porttype);
  Impact_S_PrintBmpInFlash(g_hComm,Porttype,1, Impact_BITMAP_PRINT_NORMAL);
  Impact_S_PrintBmpInFlash(g_hComm,Porttype,2, Impact_BITMAP_PRINT_NORMAL);

  ///////////////////////////////////////////////////////////////
  ///  λڱָ 1D 0C
  ///  ͨImpact_WriteFile͡1D 0Cʵֶλڱ깦ܣ
  ///////////////////////////////////////////////////////////////
  //λڱ
  pszData:=#$1D#$0C;
  Impact_WriteFile(g_hComm,Porttype,pszData,2);

  ///////////////////////////////////////////////////////////////////////
  ///  ֽֽģʽ
  ///  Impact_CutPaper(
  ///  hPort:Thandle;         򿪵Ķ˿ھ
  ///  nPortType:Integer;     ˿
  ///  nMode:integer;         ָֽģʽ
  ///  nDistance:integer)     nModeΪImpact_CUT_MODE_FULLImpact_CUT_MODE_PARTIALʱָֽȵĵ
  ///
  ///  nMode嶨£
  ///  Impact_CUT_MODE_FULL_NoMarker        = 0;   // ȫ, ұ
  ///  Impact_CUT_MODE_PARTIAL_NoMarker     = 1;   // Уұ
  ///  Impact_CUT_MODE_FULL                 = $41; // ȫУұ
  ///  Impact_CUT_MODE_PARTIAL              = $42; // Уұ
  ////////////////////////////////////////////////////////////////////////
	Impact_CutPaper(g_hComm,Porttype,Impact_CUT_MODE_PARTIAL_NoMarker, 0);

  // ݺָļĲ
	if(ChkWrite.Checked = true) then Impact_EndSaveFile(g_hComm);

  edQuery.Text:='ӡɹ!';
end;

end.
